


#declare AllGraniteMacros = array {"Granite_03_Test", "Granite_03_default", "Granite_03_Test2"}

#declare _not0 = 1/256; // a small non-zero value
#declare help = true;

#macro GranitesIndex ()
	#local _NumMacros = dimension_size (AllGraniteMacros, 1)-1;
	#debug "The Granites.inc file contains the following texture generation macros: \n"
	#debug "====================================================================== \n"
	#debug concat (
	#for (_element, 0, _NumMacros)
		"#macro ", AllGraniteMacros [_element], " \n",
	#end
	"====================================================================== \n\n")
#end

// another way to do this would be to actually call each macro with an "information only" 
// argument, which would print out the relevant info and do an #error "end scene"

// veins and inclusions
// I clearly recall a thread where someone had a pattern of some sort that looked like
// one texture visible in wavy "cracks" in another - any ideas where that is?

#macro Granite_03_Test (
	optional _ColorMap1, 
	optional _Quality, 
	optional _Verbose
	)
	#ifdef (_Verbose)
		#if (_Verbose)
			#debug "-------------------------------------------------------------\n"
			#debug "#macro Granite_03_Test () [verbose output]\n"
			#debug "3 parameters: colormap (ident), quality (int), verbose (bool)\n"
			#debug "All parameters are optional. \n"
			#debug "-------------------------------------------------------------\n"
		#end
	#end

	#local CM_MP1 = 
	color_map {
				[0.00 rgb <_not0, _not0, _not0>]
				[0.25 rgb <0.059, 0.059, 0.059>]
				[0.25 rgb <0.086, 0.027, 0.059>]
				[0.35 rgb <0.118, 0.118, 0.078>]
				[0.35 rgb <0.200, 0.137, 0.110>]
				[1.00 rgb <0.769, 0.329, 0.298>]
			}
			
	#local CM_MP2 = 
	color_map {
					[0.00 rgbt <0.200, 0.200, 0.200, 0.149>]
					[0.25 rgbt <0.200, 0.200, 0.200, 0.949>]
					[0.25 rgbt <1.000, 1.000, 1.000, 1.000>]
					[1.00 rgbt <1.000, 1.000, 1.000, 1.000>]
				}


	#local MohoganyPol_1 =
	texture {
		pigment {
			granite
			//turbulence 0.4
			#ifdef (_ColorMap1)
				color_map {_ColorMap1}
			#else
				color_map {CM_MP1}
			#end
		scale 0.1 //0.8
		}
		finish {
			diffuse 0.6
			brilliance 1.5
			specular 0.9
			roughness 0.005
		}
	}
	
	#local MohoganyPol_2 =
	texture {MohoganyPol_1}
	texture {
		pigment {
			granite
			turbulence 0.2
				color_map {CM_MP2}
			scale 0.3
			translate <20.0, 20.0, 33.0>
			rotate <0.3, 0.2, 0.0>
		}
		finish {
			diffuse 0.8
			brilliance 1.5
			specular 0.9
			roughness 0.005
		}
	}
	#if (0)
		#warning "Message"
	#end

	MohoganyPol_2

#end

#macro Granite_03_default (optional _Trigger)
	#ifdef (_Trigger)
		#debug "texture macro: Granite_03_default \n"
		#debug "invokes texture macro: Granite_03_Test \n"
		#debug "3 parameters: colormap (ident), quality (int), verbose (bool)\n"
		#debug "All parameters are optional. \n"
	#end
	Granite_03_Test (,,) 
#end

#macro Granite_03_Test2 (
	optional _ColorMap3, 
	optional _Quality, 
	optional _Verbose
	)
	#ifdef (_Verbose)
		#if (_Verbose)
			#debug "#macro Granite_03_Test2 () \n"
			#debug "3 parameters: colormap (ident), quality (int), verbose (bool)\n"
			#debug "All parameters are optional. \n"
		#end
	#end

	/*
	layering fractal noise
	different noise generator functions
	*/
	#local M = 1; //1.75;
	#local CM_MP3 = 
	color_map {
				[0.00 rgb <_not0, _not0, _not0>]
				[0.25 rgb <0.059, 0.059, 0.059>*M]
				[0.25 rgb <0.086, 0.027, 0.059>*M]
				[0.35 rgb <0.118, 0.118, 0.078>*M]
				[0.35 rgb <0.200, 0.137, 0.110>*M]
				[1.00 rgb <0.769, 0.329, 0.298>*M]
			}
	#local CM_MP3a = 
	color_map {
				#local Entry1 = srgb <_not0, _not0, _not0>;
				[0.00 Entry1*M]
				#local Entry2 = srgb <0.059, 0.059, 0.059>;
				[0.25 Entry2*M]
				#local Entry3 = srgb <0.086, 0.027, 0.059>;
				[0.25 Entry3*M]
				#local Entry4 = srgb <0.118, 0.118, 0.078>;
				[0.35 Entry4*M]
				#local Entry5 = srgb <0.200, 0.137, 0.110>;
				[0.35 Entry5*M]
				#local Entry6 = srgb <0.769, 0.329, 0.298>;
				[1.00 Entry6*M]
			}
			
	#local CM_MP4 = 
	color_map {
					[0.00 rgbt <0.200, 0.200, 0.200, 0.149>]
					[0.25 rgbt <0.200, 0.200, 0.200, 0.949>]
					[0.25 rgbt <1.000, 1.000, 1.000, 1.000>]
					[1.00 rgbt <1.000, 1.000, 1.000, 1.000>]
				}


	#local MohoganyPol_3 =
	texture {
		pigment {
			granite
			//turbulence 0.4
			#ifdef (_ColorMap3)
				color_map {_ColorMap3}
			#else
				color_map {CM_MP3}
			#end
		scale 0.1 //0.8
		}

	}
	
	#local MohoganyPol_4 =
	material {
		//texture {MohoganyPol_3}
		texture {
			pigment {
				granite
				scale 0.1
				turbulence 0.2
					color_map {CM_MP3} // <--- not the rgbt for sslt!
				
				translate <20.0, 20.0, 33.0>
				rotate <0.3, 0.2, 0.0>
			}
			finish {
				subsurface {translucency <0.4562, 0.3811,0.3325>}
				diffuse 0.8
				brilliance 1.5
				specular 0.9
				metallic 0.25
				reflection {0.01, 0.2 fresnel on falloff 1.2}
        			conserve_energy
				roughness 0.005
			}
		}
		interior {ior 1.5}
	}

	#local Tex2 = 
	material {MohoganyPol_4
	}
	
	//Tex2  // this does NOT work for some strange reason!  
	MohoganyPol_4

#end

